<?php
class GumballMachine {
   const SOLD_OUT = 0;
   const NO_QUARTER = 1;
   const HAS_QUARTER = 2;
   const SOLD = 3;

   private $state = self::SOLD_OUT;
   private $count = 0;

   public function __construct( $count = 0 ) {
      $this->count = $count;
      
      if( $this->count > 0 ) {
         $this->state = self::NO_QUARTER;
      }
   }

   public function insertQuarter() {
      if( $this->state === self::HAS_QUARTER ) {
         echo "You can't insert another quarter\n";
      } else if( $this->state === self::NO_QUARTER ) {
         $this->state = self::HAS_QUARTER;
         echo "You inserted a quarter\n";
      } else if( $this->state === self::SOLD_OUT ) {
         echo "You can't insert a quarter. The machine is sold out.\n";
      } else if( $this->state === self::SOLD ) {
         echo "Please wait, we're already giving you a gumball\n";
      }
   }

   public function ejectQuarter() {
      if( $this->state === self::HAS_QUARTER ) {
         echo "Quarter returned.\n";
         $this->state = self::NO_QUARTER;
      } else if( $this->state === self::NO_QUARTER ) {
         echo "You haven't inserted a quarter.\n";
      } else if( $this->state === self::SOLD_OUT ) {
         echo "You can't eject, you haven't inserted a quarter yet.\n";
      } else if( $this->state === self::SOLD ) {
         echo "Sorry, you already turned the crank.\n";
      }
   }

   public function turnCrank() {
      if( $this->state === self::HAS_QUARTER ) {
         echo "You turned...\n";
         $this->state = self::SOLD;
         $this->dispanse();
      } else if( $this->state === self::NO_QUARTER ) {
         echo "You turned but there is no quarter.\n";
      } else if( $this->state === self::SOLD_OUT ) {
         echo "You turned but there are no gumballs.\n";
      } else if( $this->state === self::SOLD ) {
         echo "Turning twice doesn't get you another gumball!\n";
      }
   }

   public function dispanse() {
      if( $this->state === self::HAS_QUARTER ) {
         echo "No gumball dispansed.\n";
      } else if( $this->state === self::NO_QUARTER ) {
         echo "You need to pay first\n";
      } else if( $this->state === self::SOLD_OUT ) {
         echo "No gumball dispansed.\n";
      } else if( $this->state === self::SOLD ) {
         echo "A gumball comes rolling out the slot\n";
         $this->count--;
         if( $this->count === 0 ) {
            echo "Oops, out of gumballs!\n";
            $this->state = self::SOLD_OUT;
         } else {
            $this->state = self::NO_QUARTER;
         }
      }
   }

   public function __toString() {
      $string = "\nMighty Gumball, Inc. \nJava-enabled Standing Gumball Model #2013\nInventory: $this->count\n";

      switch( $this->state ) {
         case self::SOLD_OUT:
            $string .= "Machnine is sold out.\n\n";
            break;
         default:
            $string .= "Machnine is waiting for quarter.\n\n";
            break;
      }

      return $string;
   }
}

