<?php
class GumballMachine {
   private $soldOutState;
   private $noQuarterState;
   private $hasQuarterState;
   private $soldState;
   private $winnerState;
   
   private $currentState;
   private $count = 0;

   public function __construct( $numberOfGumballs = 0 ) {
      $this->soldOutState = new SoldOutState( $this );
      $this->noQuarterState = new NoQuarterState( $this );
      $this->hasQuarterState = new HasQuarterState( $this );
      $this->soldState = new SoldState( $this );
      $this->winnerState = new WinnerState( $this );
      
      $this->count = $numberOfGumballs;

      if( $this->count > 0 ) {
         $this->currentState = $this->noQuarterState;
      } else {
         $this->currentState = $this->soldOutState;
      }
   }
   
   public function insertQuarter() {
      $this->currentState->insertQuarter();
   }

   public function ejectQuarter() {
      $this->currentState->ejectQuarter();
   }

   public function turnCrank() {
      $this->currentState->turnCrank();
      $this->currentState->dispense();
   }

   public function setState( State $state ) {
      $this->currentState = $state;
   }

   public function releaseBall() {
      echo "Gumball comes rolling out the slot...\n";
      if( $this->count !== 0 ) {
         $this->count--;
      }
   }
   public function getHasQuarterState() {
      return $this->hasQuarterState;
   }

   public function getSoldOutState() {
      return $this->soldOutState;
   }

   public function getSoldState() {
      return $this->soldState;
   }

   public function getNoQuarterState() {
      return $this->noQuarterState;
   }

   public function getWinnerState() {
      return $this->winnerState;
   }

   public function getCount() {
      return $this->count;
   }

   public function __toString() {
	   $string = "\nMighty Gumball, Inc. \nJava-enabled Standing Gumball Model #2013\nInventory: $this->count\n";

	   switch( get_class( $this->currentState ) ) {
		   case 'SoldOutState':
			   $string .= "Machnine is sold out.\n\n";
			   break;
		   default:
			   $string .= "Machnine is waiting for quarter.\n\n";
			   break;
	   }

	   return $string;
   }

}
