<?php
class HasQuarterState implements State {
	private $gumballMachine = null;

	public function __construct( $gumballMachine ) {
		$this->gumballMachine = $gumballMachine;
	}

	public function insertQuarter() {
		echo "You can't insert another quarter.\n";
	}

	public function ejectQuarter() {
		echo "Quarter returned.\n";
		$this->gumballMachine->setState( $this->gumballMachine->getNoQuarterState() );
	}

	public function turnCrank() {
		echo "You turned...\n";

		$winner = rand( 1, 10 );
		if( $winner === 10 && $this->gumballMachine->getCount() > 1 ) {
			$this->gumballMachine->setState( $this->gumballMachine->getWinnerState() );
		} else {
			$this->gumballMachine->setState( $this->gumballMachine->getSoldState() );
		}
	}

	public function dispense() {
		echo "No gumball dispensed.\n";
	}
}
